#include <inc/lib.h>

int
strecmp(const char *a, const char *b)
{
	while (*b)
		if (*a++ != *b++)
			return 1;
	return 0;
}

const char *msg = "This is the NEW message of the day!\n\n";

#define FVA (struct Fd*)0xCCCCC000

void
umain(int, char **)
{
	int r, fileid;

	if ((r = fsipc(FSREQ_OPEN, -1, O_RDONLY, "/not-found", FVA, NULL)) < 0
	    && r != -E_NOT_FOUND)
		panic("serve_open /not-found: %e", r);
	else if (r == 0)
		panic("serve_open /not-found succeeded!");

	if ((r = fsipc(FSREQ_OPEN, -1, O_RDONLY, "/newmotd", FVA, NULL)) < 0)
		panic("serve_open /newmotd: %e", r);
	FileFd *fd = (FileFd *) FVA;
	if (strlen(msg) != fd->fd_file.f_size)
		panic("serve_open returned size %d wanted %d\n", fd->fd_file.f_size, strlen(msg));
	cprintf("serve_open is good\n");

	if ((r = fsipc(FSREQ_MAP, fd->fd_fileid, 0, NULL, (void *) UTEMP, NULL)) < 0)
		panic("serve_map: %e", r);
	if (strecmp((char *) UTEMP, msg) != 0)
		panic("serve_map returned wrong data");
	cprintf("serve_map is good\n");

	if ((r = fsipc(FSREQ_CLOSE, fd->fd_fileid, 0, NULL, NULL, NULL)) < 0)
		panic("serve_close: %e", r);
	cprintf("serve_close is good\n");
	fileid = fd->fd_fileid;
	sys_page_unmap(0, (void*) FVA);

	if ((r = fsipc(FSREQ_MAP, fileid, 0, NULL, (void *) UTEMP, NULL)) != -E_INVAL)
		panic("serve_map does not handle stale fileids correctly");
	cprintf("stale fileid is good\n");
}

